# Synthetic Channels

This repository contains documentation for experimental synthetic channels for Swabian Instruments TimeTagger suite. The code for the synthetic channels themselves maybe found in the `SignalGenerators.cpp` file in the Time Tagger repository.

A synthetic channel is a virtual channel which produces synthetic TimeTags, usually corresponding to some physical process.

The class `SignalGeneratorBase` provides the framework behind generating new TimeTags, by providing a `get_next()` call to `IteratorBase`. By sampling random numbers from a probability distribution and adding them to some base time, we may create a signal of TimeTags whose differences follows this distribution. This is done in the 

* `UniformSignalGenerator`
* `GaussianSignalGenerator`
* `ExponentialSigmaGenerator`
* `GammaSignalGenerator`

These may be used to model simple physical effects, i.e. simulating dark counts in a single photon detector by using `ExponentialSignalGenerator`. 
## The "Photon" Generator Class

In more complex physical scenarios, light triggers some detector which sends an electric signal which is tagged by the TimeTagger. One may create Tags by stochastically modelling the light intensity (absolute squared value of electric field) of some physical process and **inverting** it to create the next time.

This forms the idea behind the `PhotonGenerator` class. It contains a `get_new_stamp()` function call which samples an exponential distribution (in time, which corresponds to a Poisson distribution in counts) and multiplies this time by the inverse of the intensity and scales by the countrate (Tags/s) in order to model a laser induced process. 

```C++
timestamp_t PhotonGenerator::get_new_stamp() {
  return static_cast<timestamp_t>(llround(exp_distribution(generator) * 1E12 * 1 / current_intensity));
}
```

The intensity process itself is not specified in the class and is dependent on the physical process to be modelled. The signal generators correponding to laser processes must thus subclass `PhotonGenerator` and provide their own implmenetation of `get_intensity()`. This is done in the

* `DlsSignalGenerator`
* `FcsSignalGenerator`

classes. The implementation of these two processes is outlined below. 

In general, TimeTags generated by an underlying intensity process should be consistent  with the internal temporal evolution of the system itself. That is,when new timestamps are generated by random sampling, the underlying time dynamics of the system being modelled are not one-to-one with the generated time tags. There are thus two related but distinct time domains, the Tag time and the simulation time. To keep track of the latter, an internal clock has to be maintained via a loop construct which  ensures that each new Tag takes into the account not only the previous TimeTags but how much time *should* have ellapsed before a new intensity could be generated:

```C++
timestamp_t PhotonGenerator::get_next() {
    // create a timestamp
  timestamp_t new_stamp = get_new_stamp();
// is this time stamp greater than the difference of between the elapsed time and one period?
// if so, run the loop
  while (accumulated + new_stamp - t_evolution >= 0) {
    // retrieve a new intensity (evolves subsystem)
    current_intensity = get_intensity();

    // store elapsed time in accumulated,
    accumulated = t_evolution;

    // update clock by T_PERIOD
    t_evolution += T_PERIOD;

    // generate a new timestamp and run the loop again
    new_stamp = get_new_stamp();
  }

// new time stamp is guaranteed to be  within a period of internal evolution.
  accumulated += new_stamp;

  // return the cumulative time as the next time stamp
  return base_time + accumulated;
}
```

Another way to interpret this is to note that the loop repeatedly gets new intensities until an intensity is obtained which within one period of the elapsed time.

### Python support

Since the `PhotonGenerator` class is so general, requiring only a `get_intensity()` function to be defined by its subclasses, one can use the Python wrapper to create our synthetic channels. In order to do this, we have to tell SWIG in the `TimeTagger.Python.i` file to have the `PhotonGenerator` as a director, which is to be subclassed:

```C
%feature("director") PhotonGenerator;
%feature("nodirector") SignalGeneratorBase::initialize; // these two lines are to
%feature("nodirector") SignalGeneratorBase::get_next;   // prevent things breaking elsewhere
```

Python implementations for DLS and FCS are provided in this repository.
## Dynamic Light Scattering (DLS)

DLS is a technique to determine particle size for matter suspended in solution. By shining laser light unto a sample, one receives the noisy reflection of the light incident on the floating particles, the so-called speckle pattern. This pattern varies as the particles undergo Brownian motion in the fluid. By measuring the autocorrelation of this signal, i.e. how the signal changes in time, one can determine the properties of this motion and relate this to particle size.

The intensity of the speckle pattern measured at a detector is given by the coherent superposition of the reflection of each individual molecule

$$
E(t) \propto \sum_k \exp\left( i \; \varphi_k (t)\right)
\tag{1}
$$

where the phase $\varphi(t)$ varies as the particle undergoes Brownian motion. Brownian motion is random motion characterized by normally distributed diffusion with a zero mean displacement, $\mu=0$, but a temporally linear variance

$$
\sigma^2(t) = 2\cdot D \cdot t
$$

with diffusion coefficient $D$. This coefficient can be related to the decay constant $\Gamma$ of the autocorrelated DLS signal

$$g_2(\tau)=1+e^{-2\;\Gamma\thinspace\tau}$$

via the relationship
$$
\Gamma=q^2\;D
$$
 
where the factor $q=\frac{4 \pi}{\lambda} n \sin(\theta/2)$ relates the laser wavelength ($\lambda$), refractive index ($n$) and angle of incidence ($\theta$) of the experimental setup. Note that we can take $q=1$ in our simulation, without loss of generality. The appproximate particle radius at temperature $T$ can then be deduced via the Stokes-Einstein relation $D\propto k_B T/r$, or by more complex algorithms.

With this in mind, for a given decay rate $\Gamma$, we may model the intensity generated by the simplest DLS system by considering an array of particles with an associated phase. To generate intensities, we 

1. sample random variables from a normal distribution $\mathcal{N}(0,\sigma)$, 
1. add this new phase shift to the phase of each particle,
1. calculate the above sum in Eq. $(1)$ over all particles. 

The absolute value of this phase sum, normalized by the number of particles, will be the intensity, which the function `get_intensity()` receives.

This can be programmed as a simple class in Python:

```Python
class DLS(Experimental.PhotonGenerator):
    def __init__(self, tagger, countrate, channel):
        super().__init__(tagger, countrate, channel, 1)
        self.finalize_init()
        self.std_dev = np.sqrt(2 * T_PERIOD / decay_t)
        self.phases = np.random.uniform(0, 2*np.pi, N)

    def __del__(self):
        self.stop()

    def get_intensity(self):
        self.phases += rng.normal(0, self.std_dev, N)
        return 1/ N * np.abs(np.sum(np.exp(self.phases*1j)))**2
```
The backend C++ implementation of DLS follows the same structure.

This model can be extended to several different particle types by specifying different decay constants $\Gamma_i$ and sampling from the relevant normal distributions $\mathcal{N}(0, \sigma_i)$. By virtue of the scaling property of normal distributions, viz. $\mathcal{N}(0, \sigma) \sim \sigma \thinspace \mathcal{N}(0,1)$, we can take all samples from the standard normal distribution and scale accordingly for each decay constant.

### Dust

A real life DLS apparatus also has to deal with large molecules which distort the signal by interefering with the laser signal, either in the experimental chamber or in the solution. This is colloquially known as dust, although any impurity which wanders into the laser beam, in solution or otherwise, would affect the intensity signal. 

Therefore, a way to model dust would be to have a random walk in both spatial as well as phase  space and whenever the dust particle is incident on the focus to add its phase space contribution to the sum.
## Fluorescence Correlation Spectroscopy (FCS)

FCS is a technique wherein fluorescent dyes (e.g. Rhodamine 6G) are added to a solution and subsequently excited by a confocal laser. Using a pinhole camera to isolate the signal from a very small volume, the autocorrelation of this signal reveals information on the concentration and particle dynamics of the solution. We restrict oursleves to two dimensions, although a generalisation to three dimensional is straightforward, where the autocorrelation function can be shown to be

$$
g_2(\tau)=1+\frac{1}{N} \;\dfrac 1 {1+\frac{\tau}{\tau_D}}.
$$

The intensity produced by a particle in the focus of a gaussian laser beam with waist radius $w_0$ is given by

$$
I(\vec{r}, t)= |E_0|^2 \exp(- \frac{2\,r^2}{w_0^2}).
$$

where $\vec{r}$ is the 2D radial vector from the laser beam situated at the origin to the particle coordinates. We can model simulate Brownian motion of fluorophores in two dimensional space and then use the above formula to calculate to overall intensity: 

$$
I(t) \propto \times \sum_{i=1}^{N} \exp(- \frac{2\,R_i^2}{w_0^2}).
$$

Here $R_i$ are the positions of the particles, which are evolved by adding independent identically distributed random variables drawn from a normal distribution $\mathcal{N}(0, \sigma^2)$ corresponding to Brownian motion. The diffusion coefficient $D =w_0^2/(4 \tau_D)$ implies a standard deviation

$$
\sigma = w_0\, \sqrt{\frac{T_p}{2\; \tau_d}}\,
$$
for simple diffusion. Diffusion with flow could be modelled by changing this relationship. For equality, this sum should be averaged over the intensity of each particle,

$$
\bar{I}=\int dV\; \exp(- \frac{2\,r^2}{w_0^2}) = \pi\;w_0^2 /2,
$$

as well as over the total area $A=\pi w_0^2b^2$, where $b$ is the boundary of the simulation. Thus, the total normalized intensity is given by


$$
I(t)= \frac{2}{\overline{N}} \times \sum_{i=1}^{N} \exp(- \frac{2\,R_i^2}{w_0^2}).
$$

where $\bar{N}=N/b^2$ is the average number of particles in the focus.
### Boundary Conditions

The importance of the factor $b$ is not to be underestimated, since we must define what happens when a particle crosses the boundary. Currently there are two implementations

* Pacman/Reflecting boundary conditions:
  * If a particle leaves the area on one side, it enters via the opposite side:
  
$$
(r+dr)^2> b^2 w_0^2 \quad \longrightarrow \quad r +dr \rightarrow -r +dr
$$
  
* Sticky/Clipped boundary conditions:
  * If a particle crosses the boundary, it's repositioned on the boundary:
    
$$
|x_i| > \frac{\sqrt{\pi}}2 \, b \, w_0 \quad \longrightarrow \quad x_i \rightarrow  \pm \frac{\sqrt{\pi}}2 \, b\,w_0
$$

where $x_{i=1,2}$ represents either $x$ or $y$ cartesian coordinates. The factor $\frac{\sqrt{\pi}}2$ ensures both boundary conditions result in an effectiva area $A=\pi \thinspace b^2\thinspace w_0^2$.

The important thing to note is that FCS measures particles in the focus and if the boundary of the simulation is too small with respect to the waist radius (which is where the vast majority of contributions to the overall intensity arise) this will manifest itself in a higher concentration, since particles will be artificially held near the focus. For large boundaries this is not an issue, and heuristically we have found $b=10$ to be a suitable length. Thus we define a minimum boundary $b_{min}=10$ and calculate 

$N=\lceil \thinspace \overline{N} \thinspace b_{min}^2 \rceil$

as a function of the input avergae number of particles $\overline{N}$ and then calculate appropariate boundary from this:

$$
b = \sqrt{\frac{N}{\overline{N}}}
$$

so that we can simulatenously maintain a large boundary, have an exact concentration and ensure a non-zero number of fluorophores in the simulation.

Note also that all displacements in space are always specified in units of the waist raidus $w_0$. Thus, we may set $w_0=1$ without loss of generality and speak only of the average number of fluorophores in the focus, which is related to concentration. 

## Authors and acknowledgment

The DLS and FCS synthetic channels were developed by Daniel Bakucz Canário with the help of Markus Wick, as well as Tim Wolz and Igor Shavrin (DLS), and Mirco Kolarczik (FCS).
